Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.cpp	(revision 1520)
@@ -4,4 +4,5 @@
 #include <iostream>
 #include <fstream>
+#include "ep_mpi.hpp"
 
 using namespace std;
@@ -14,11 +15,4 @@
 namespace ep_lib
 { 
-  bool MPI_Comm::is_null()
-  {
-    if(!this->is_intercomm)
-      return this->mpi_comm == MPI_COMM_NULL.mpi_comm;
-    else
-      return this->ep_comm_ptr->intercomm->mpi_inter_comm == MPI_COMM_NULL.mpi_comm;
-  }
 
   int tag_combine(int real_tag, int src, int dest)
@@ -33,50 +27,36 @@
   int get_ep_rank(MPI_Comm comm, int ep_rank_loc, int mpi_rank)
   {
-    for(int i=0; i<comm.rank_map->size(); i++)
-    {
-      if(   ( comm.rank_map->at(i).first  == ep_rank_loc )
-         && ( comm.rank_map->at(i).second == mpi_rank ) )
-      {
-        return i;
-      }
-    }
-    printf("rank not find\n");
+    if(comm->is_intercomm)
+    {
+      for(std::map<int, std::pair< int, std::pair<int, int> > >::iterator it = comm->ep_comm_ptr->intercomm->intercomm_rank_map->begin(); it != comm->ep_comm_ptr->intercomm->intercomm_rank_map->end(); it++)
+      {
+        if(   ( it->second.first  == ep_rank_loc )
+           && ( it->second.second.first == mpi_rank ) )
+        {
+          return it->first;
+        }
+      }
+      printf("rank not find for EP_intercomm\n");
+      int err;
+      return MPI_Abort(comm, err);
+    }
+    
+    for(std::map<int, std::pair<int, int> >::iterator it = comm->ep_rank_map->begin(); it != comm->ep_rank_map->end(); it++)
+    {
+      if(   ( it->second.first  == ep_rank_loc )
+         && ( it->second.second == mpi_rank ) )
+      {
+        return it->first;
+      }
+    }
+    printf("rank not find for EP_intracomm\n");
+    int err;
+    return MPI_Abort(comm, err);
   }
   
-  int get_ep_rank_intercomm(MPI_Comm comm, int ep_rank_loc, int mpi_rank)
-  {
-    // intercomm
-    int inter_rank;
-    for(int i=0; i<comm.ep_comm_ptr->intercomm->intercomm_rank_map->size(); i++)
-    {
-      if(   ( comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(i).first  == ep_rank_loc )
-         && ( comm.ep_comm_ptr->intercomm->intercomm_rank_map->at(i).second == mpi_rank ) )
-      {
-        inter_rank =  i;
-        break;
-      }
-    }
-
-    for(int i=0; i<comm.ep_comm_ptr->intercomm->remote_rank_map->size(); i++)
-    {
-      if(  comm.ep_comm_ptr->intercomm->remote_rank_map->at(i).first  == inter_rank  )
-      {
-        //printf("get_ep_rank for intercomm, ep_rank_loc = %d, mpi_rank = %d => ep_src = %d\n", ep_rank_loc, mpi_rank, i);
-        return i;
-      }
-    }
-
-    printf("rank not find\n");
-    
-  }
-
 
   int MPI_Get_count(const MPI_Status *status, MPI_Datatype datatype, int *count)
   {
-
-    ::MPI_Status *mpi_status = static_cast< ::MPI_Status* >(status->mpi_status);
-    ::MPI_Datatype *mpi_datatype = static_cast< ::MPI_Datatype*>(datatype);
-
-    ::MPI_Get_count(mpi_status, *mpi_datatype, count);
+    return ::MPI_Get_count(to_mpi_status_ptr(*status), to_mpi_type(datatype), count);
   }
 
@@ -89,4 +69,5 @@
   void check_sum_send(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, int type)
   {
+
     int src_rank;
     int int_count;
@@ -121,4 +102,5 @@
   void check_sum_recv(void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, int type)
   {
+
     int dest_rank;
     int int_count;
@@ -147,4 +129,5 @@
     }
     else printf("Unable to open file\n");
+
 
   }
@@ -251,4 +234,9 @@
 {
   return *(static_cast< MPI_Comm* >(comm));
+} 
+
+MPI_Comm* to_mpi_comm_ptr(void* comm)
+{
+  return static_cast< MPI_Comm* >(comm);
 }  
 
@@ -258,11 +246,34 @@
 }
 
-MPI_Info to_mpi_info(void* info)
-{
-  return *(static_cast< MPI_Info* >(info));
-}
-
-
-
-
-
+MPI_Message* to_mpi_message_ptr(ep_lib::MPI_Message message)
+{
+  return static_cast< MPI_Message* >(message->mpi_message);
+}
+
+MPI_Info to_mpi_info(ep_lib::MPI_Info info)
+{
+  return *(static_cast< MPI_Info* >(info->mpi_info));
+}
+
+MPI_Win to_mpi_win(void* win)
+{
+  return *(static_cast< MPI_Win* >(win));
+}
+
+MPI_Aint to_mpi_aint(ep_lib::MPI_Aint aint)
+{
+  return *(static_cast< MPI_Aint* >(aint.mpi_aint));
+}
+
+MPI_Status* to_mpi_status_ptr(ep_lib::MPI_Status status)
+{
+  return static_cast< MPI_Status* >(status.mpi_status);
+}
+
+MPI_Request* to_mpi_request_ptr(ep_lib::MPI_Request request)
+{
+  return static_cast< MPI_Request* >(request->mpi_request);
+}
+
+
+
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.hpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib.hpp	(revision 1520)
@@ -4,8 +4,13 @@
 #include "ep_type.hpp"
 #include "ep_lib_intercomm.hpp"
+#include "ep_lib_intracomm.hpp"
 #include "ep_lib_local.hpp"
 #include "ep_lib_collective.hpp"
 #include "ep_tag.hpp"
 #include "ep_lib_fortran.hpp"
+#include "ep_lib_win.hpp"
+#include "ep_lib_mpi.hpp"
+//#include "ep_mpi.hpp"
+
 
 namespace ep_lib
@@ -33,12 +38,6 @@
 
   int MPI_Get_count(const MPI_Status *status, MPI_Datatype datatype, int *count);
-
-  // #ifdef _openmpi
-  // int MPI_Comm_create_endpoints(void* mpi_comm, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls); // from MPI to create endpoints
-  // #elif _intelmpi
-  // int MPI_Comm_create_endpoints(int mpi_comm, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls); // from MPI to create endpoints
-  // #endif
   
-  int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls); // from EP to create endpoints
+  int MPI_Comm_remote_size(MPI_Comm comm, int *size);
 
   int MPI_Send(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
@@ -47,10 +46,4 @@
   int MPI_Issend(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
 
-  int tag_combine(int real_tag, int src, int dest);
-  int get_ep_rank(MPI_Comm comm, int ep_rank_loc, int mpi_rank);
-  int get_ep_rank_intercomm(MPI_Comm comm, int ep_rank_loc, int mpi_rank);
-
-  int Message_Check(MPI_Comm comm);
-  int Request_Check();
 
   int MPI_Recv  (void *buf, int count, MPI_Datatype datatype, int src, int tag, MPI_Comm comm, MPI_Status *status);
@@ -74,4 +67,6 @@
   int MPI_Alloc_mem(unsigned long size, MPI_Info info, void *baseptr);
 
+  int MPI_Comm_test_inter(MPI_Comm comm, int *flag);
+
 
   void check_sum_send(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, int type);
@@ -81,4 +76,14 @@
   bool valid_op(MPI_Op op);
 
+  int tag_combine(int real_tag, int src, int dest);
+  int get_ep_rank(MPI_Comm comm, int ep_rank_loc, int mpi_rank);
+
+  int Message_Check(MPI_Comm comm);
+
+  int Request_Check();
+
+  int test_sendrecv(MPI_Comm comm);
+
+
 }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_collective.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_collective.hpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_collective.hpp	(revision 1520)
@@ -10,4 +10,5 @@
 
   int MPI_Barrier(MPI_Comm comm);
+  
 
   int MPI_Comm_dup(MPI_Comm comm, MPI_Comm *newcomm);
@@ -26,4 +27,5 @@
 
   int MPI_Gather(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, int root, MPI_Comm comm);
+  
   int MPI_Allgather(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm);
 
@@ -41,4 +43,23 @@
   int MPI_Alltoall(const void *sendbuf, int sendcount, MPI_Datatype sendtype, void *recvbuf, int recvcount, MPI_Datatype recvtype, MPI_Comm comm);
 
+  int MPI_Comm_split(MPI_Comm comm, int color, int key, MPI_Comm *newcomm);
+
+  int MPI_Intercomm_create(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
+
+  int MPI_Intercomm_create_kernel(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
+  
+  
+  int MPI_Intercomm_create_from_world(MPI_Comm local_comm, int local_leader, void* peer_comm_ptr, int mpi_remote_leader, int tag, MPI_Comm *newintercomm);
+  
+  int MPI_Intercomm_create_unique_leader(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
+
+  int MPI_Comm_create_endpoints(void* base_comm_ptr, int num_ep, MPI_Info info, MPI_Comm *& out_comm_hdls); // from EP to create endpoints
+
+
+
+  int MPI_Intercomm_merge(MPI_Comm intercomm, bool high, MPI_Comm *newintracomm);
+
+  int MPI_Intercomm_merge_unique_leader(MPI_Comm intercomm, bool high, MPI_Comm *newintracomm);
+
 }
 
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_intercomm.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_intercomm.hpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_intercomm.hpp	(revision 1520)
@@ -8,5 +8,11 @@
   typedef void* MPI_Op;
 
-  
+  int MPI_Send_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
+  int MPI_Ssend_intercomm(void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm);
+  int MPI_Isend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
+
+  int MPI_Issend_intercomm(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request);
+
+
   int MPI_Comm_dup_intercomm(MPI_Comm comm, MPI_Comm *newcomm);
 
@@ -22,33 +28,8 @@
 
   int MPI_Iprobe_intercomm(int source, int tag, MPI_Comm comm, int *flag, MPI_Status *status);
-  int MPI_Iprobe_any_source(int tag, MPI_Comm comm, int *flag, MPI_Status *status);
   int MPI_Improbe_intercomm(int source, int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status);
-  int MPI_Improbe_any_source(int tag, MPI_Comm comm, int *flag, MPI_Message *message, MPI_Status *status);
 
-  int MPI_Comm_split(MPI_Comm comm, int color, int key, MPI_Comm *newcomm);
 
-  int MPI_Intercomm_create(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
 
-  int MPI_Intercomm_create_kernel(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
-  
-  // #ifdef _intelmpi
-  // int MPI_Intercomm_create_from_world(MPI_Comm local_comm, int local_leader, int peer_comm_ptr, int mpi_remote_leader, int tag, MPI_Comm *newintercomm);
-  // #elif _openmpi
-  // int MPI_Intercomm_create_from_world(MPI_Comm local_comm, int local_leader, void* peer_comm_ptr, int mpi_remote_leader, int tag, MPI_Comm *newintercomm);
-  // #endif
-
-  int MPI_Intercomm_create_from_world(MPI_Comm local_comm, int local_leader, void* peer_comm_ptr, int mpi_remote_leader, int tag, MPI_Comm *newintercomm);
-  
-  int MPI_Intercomm_create_unique_leader(MPI_Comm local_comm, int local_leader, MPI_Comm peer_comm, int remote_leader, int tag, MPI_Comm *newintercomm);
-
-  int MPI_Intercomm_merge(MPI_Comm intercomm, bool high, MPI_Comm *newintracomm);
-
-  int MPI_Intercomm_merge_unique_leader(MPI_Comm intercomm, bool high, MPI_Comm *newintracomm);
-
-  int MPI_Comm_remote_size(MPI_Comm comm, int *size);
-
-  int MPI_Comm_test_inter(MPI_Comm comm, int *flag);
-
-  int test_sendrecv(MPI_Comm comm);
 
 }
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_local.hpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_local.hpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_lib_local.hpp	(revision 1520)
@@ -18,4 +18,6 @@
   
   int MPI_Gather_local      (const void *sendbuf, int count, MPI_Datatype datatype, void *recvbuf, int local_root, MPI_Comm comm);
+  
+  int MPI_Allgather_local      (const void *sendbuf, int count, MPI_Datatype datatype, void *recvbuf, MPI_Comm comm);
 
   int MPI_Gatherv_local       (const void *sendbuf, int count, MPI_Datatype datatype, void *recvbuf,
Index: XIOS/dev/branch_openmp/extern/src_ep_dev/ep_merge.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/src_ep_dev/ep_merge.cpp	(revision 1518)
+++ XIOS/dev/branch_openmp/extern/src_ep_dev/ep_merge.cpp	(revision 1520)
@@ -7,5 +7,6 @@
 
 
-namespace ep_lib {
+namespace ep_lib 
+{
 
   int MPI_Intercomm_merge_unique_leader(MPI_Comm inter_comm, bool high, MPI_Comm *newintracomm)
@@ -18,25 +19,25 @@
     int ep_size, num_ep, mpi_size;
 
-    ep_rank = inter_comm.ep_comm_ptr->size_rank_info[0].first;
-    ep_rank_loc = inter_comm.ep_comm_ptr->size_rank_info[1].first;
-    mpi_rank = inter_comm.ep_comm_ptr->size_rank_info[2].first;
-    ep_size = inter_comm.ep_comm_ptr->size_rank_info[0].second;
-    num_ep = inter_comm.ep_comm_ptr->size_rank_info[1].second;
-    mpi_size = inter_comm.ep_comm_ptr->size_rank_info[2].second;
+    ep_rank = inter_comm->ep_comm_ptr->size_rank_info[0].first;
+    ep_rank_loc = inter_comm->ep_comm_ptr->size_rank_info[1].first;
+    mpi_rank = inter_comm->ep_comm_ptr->size_rank_info[2].first;
+    ep_size = inter_comm->ep_comm_ptr->size_rank_info[0].second;
+    num_ep = inter_comm->ep_comm_ptr->size_rank_info[1].second;
+    mpi_size = inter_comm->ep_comm_ptr->size_rank_info[2].second;
 
     int local_high = high;
     int remote_high;
 
-    int remote_ep_size = inter_comm.ep_comm_ptr->intercomm->remote_rank_map->size();
+    int remote_ep_size = inter_comm->ep_comm_ptr->intercomm->remote_rank_map->size();
 
     int local_ep_rank, local_ep_rank_loc, local_mpi_rank;
     int local_ep_size, local_num_ep, local_mpi_size;
 
-    local_ep_rank = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].first;
-    local_ep_rank_loc = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].first;
-    local_mpi_rank = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].first;
-    local_ep_size = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].second;
-    local_num_ep = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].second;
-    local_mpi_size = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].second;
+    //local_ep_rank = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].first;
+    //local_ep_rank_loc = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].first;
+    //local_mpi_rank = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].first;
+    //local_ep_size = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[0].second;
+    //local_num_ep = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].second;
+    //local_mpi_size = inter_comm->ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[2].second;
 
 
@@ -45,6 +46,6 @@
       MPI_Status status[2];
       MPI_Request request[2];
-      MPI_Isend(&local_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &request[0]);
-      MPI_Irecv(&remote_high, 1, MPI_INT, 0, inter_comm.ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &request[1]);
+      MPI_Isend(&local_high, 1, MPI_INT, 0, inter_comm->ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &request[0]);
+      MPI_Irecv(&remote_high, 1, MPI_INT, 0, inter_comm->ep_comm_ptr->intercomm->intercomm_tag, inter_comm, &request[1]);
 
       MPI_Waitall(2, request, status);
@@ -52,5 +53,5 @@
 
 
-    MPI_Bcast(&remote_high, 1, MPI_INT, 0, *(inter_comm.ep_comm_ptr->intercomm->local_comm));
+    //MPI_Bcast(&remote_high, 1, MPI_INT, 0, inter_comm->ep_comm_ptr->intercomm->local_comm);
 
 
@@ -64,10 +65,10 @@
     int intra_ep_size, intra_num_ep, intra_mpi_size;
 
-    intra_ep_rank = newintracomm->ep_comm_ptr->size_rank_info[0].first;
-    intra_ep_rank_loc = newintracomm->ep_comm_ptr->size_rank_info[1].first;
-    intra_mpi_rank = newintracomm->ep_comm_ptr->size_rank_info[2].first;
-    intra_ep_size = newintracomm->ep_comm_ptr->size_rank_info[0].second;
-    intra_num_ep = newintracomm->ep_comm_ptr->size_rank_info[1].second;
-    intra_mpi_size = newintracomm->ep_comm_ptr->size_rank_info[2].second;
+    intra_ep_rank = (*newintracomm)->ep_comm_ptr->size_rank_info[0].first;
+    intra_ep_rank_loc = (*newintracomm)->ep_comm_ptr->size_rank_info[1].first;
+    intra_mpi_rank = (*newintracomm)->ep_comm_ptr->size_rank_info[2].first;
+    intra_ep_size = (*newintracomm)->ep_comm_ptr->size_rank_info[0].second;
+    intra_num_ep = (*newintracomm)->ep_comm_ptr->size_rank_info[1].second;
+    intra_mpi_size = (*newintracomm)->ep_comm_ptr->size_rank_info[2].second;
 
 
@@ -85,5 +86,5 @@
     if(intra_ep_rank_loc == 0)
     {
-      ::MPI_Bcast(reorder, intra_ep_size, to_mpi_type(MPI_INT), 0, to_mpi_comm(newintracomm->mpi_comm));
+      ::MPI_Bcast(reorder, intra_ep_size, to_mpi_type(MPI_INT), 0, to_mpi_comm((*newintracomm)->mpi_comm));
 
       vector< pair<int, int> > tmp_rank_map(intra_ep_size);
@@ -92,8 +93,14 @@
       for(int i=0; i<intra_ep_size; i++)
       {
-        tmp_rank_map[reorder[i]] = newintracomm->rank_map->at(i) ;
-      }
-
-      newintracomm->rank_map->swap(tmp_rank_map);
+        tmp_rank_map[reorder[i]] = (*newintracomm)->ep_rank_map->at(i) ;
+      }
+
+      //(*newintracomm)->rank_map->swap(tmp_rank_map);
+      (*newintracomm)->ep_rank_map->clear();
+      for(int i=0; i<tmp_rank_map.size(); i++)
+      {
+        (*newintracomm)->ep_rank_map->insert(std::pair< int, std::pair<int,int> >(i, tmp_rank_map[i].first, tmp_rank_map[i].second));
+      }
+      
 
       tmp_rank_map.clear();
@@ -102,5 +109,5 @@
     MPI_Barrier_local(*newintracomm);
 
-    (*newintracomm).ep_comm_ptr->size_rank_info[0].first = my_ep_rank;
+    (*newintracomm)->ep_comm_ptr->size_rank_info[0].first = my_ep_rank;
 
     if(intra_ep_rank_loc == 0)
@@ -118,108 +125,79 @@
   int MPI_Intercomm_merge(MPI_Comm inter_comm, bool high, MPI_Comm *newintracomm)
   {
-
-    assert(inter_comm.is_intercomm);
-
-    if(inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->comm_label == -99)
-    {
-        return MPI_Intercomm_merge_unique_leader(inter_comm, high, newintracomm);
-    }
-
-
-    Debug("intercomm_merge kernel\n");
-
-    int ep_rank_loc;
-    int num_ep;
-
-    ep_rank_loc = inter_comm.ep_comm_ptr->size_rank_info[1].first;
-    num_ep = inter_comm.ep_comm_ptr->size_rank_info[1].second;
-
-
-
-    int remote_ep_size = inter_comm.ep_comm_ptr->intercomm->remote_rank_map->size();
-
-
-    MPI_Barrier(inter_comm);
-
-
-    ::MPI_Comm *mpi_intracomm = new ::MPI_Comm;
-    MPI_Comm *ep_intracomm;
-
-    if(ep_rank_loc == 0)
-    {
-
-      ::MPI_Comm mpi_comm = to_mpi_comm(inter_comm.ep_comm_ptr->intercomm->mpi_inter_comm);
-
-      ::MPI_Intercomm_merge(mpi_comm, high, mpi_intracomm);
+    
+
+    assert(inter_comm->is_intercomm);
+
+    // determine if only one MPI proc
+
+        // to be completed ......
+
+    // multiple MPI proc and high differs
+
+    int newcomm_ep_rank = inter_comm->ep_comm_ptr->intercomm->size_rank_info[0].first;
+    int newcomm_ep_rank_loc = inter_comm->ep_comm_ptr->intercomm->size_rank_info[1].first;
+    int newcomm_num_ep = inter_comm->ep_comm_ptr->intercomm->size_rank_info[1].second;
+
+    int ep_rank = inter_comm->ep_comm_ptr->size_rank_info[0].first;
+    int ep_rank_loc = inter_comm->ep_comm_ptr->size_rank_info[1].first;
+    int num_ep = inter_comm->ep_comm_ptr->size_rank_info[1].second;
+
+    if(newcomm_ep_rank_loc == 0)
+    {
+      ::MPI_Comm *mpi_intracomm = new ::MPI_Comm;
+      ::MPI_Intercomm_merge(to_mpi_comm(inter_comm->ep_comm_ptr->intercomm->mpi_inter_comm), high, mpi_intracomm);
+      
       MPI_Info info;
-      MPI_Comm_create_endpoints(mpi_intracomm, num_ep, info, ep_intracomm);
-
-      inter_comm.ep_comm_ptr->comm_list->mem_bridge = ep_intracomm;
-
+      MPI_Comm *ep_comm;
+      MPI_Comm_create_endpoints(mpi_intracomm, newcomm_num_ep, info, ep_comm);
+
+      inter_comm->ep_comm_ptr->comm_list[0]->mem_bridge = ep_comm;
     }
 
     MPI_Barrier_local(inter_comm);
 
-    int inter_rank;
-    MPI_Comm_rank(inter_comm, &inter_rank);
+    int remote_num_ep = newcomm_num_ep - num_ep;
+
+    *newintracomm = inter_comm->ep_comm_ptr->comm_list[0]->mem_bridge[high? remote_num_ep+ep_rank_loc : ep_rank_loc];
+
+    int ep_size = inter_comm->ep_comm_ptr->size_rank_info[0].second;
+    int remote_ep_size = inter_comm->ep_comm_ptr->intercomm->intercomm_rank_map->size();
+
+    //printf("ep_size = %d, remote_ep_size = %d\n", ep_size, remote_ep_size);
+
+    (*newintracomm)->ep_comm_ptr->size_rank_info[0].first = high? remote_ep_size+ep_rank : ep_rank;
+
+    int my_triple[3];
+    my_triple[0] = (*newintracomm)->ep_comm_ptr->size_rank_info[0].first;
+    my_triple[1] = (*newintracomm)->ep_comm_ptr->size_rank_info[1].first;
+    my_triple[2] = (*newintracomm)->ep_comm_ptr->size_rank_info[2].first;
+
+    int *my_triple_list = new int[3 * (*newintracomm)->ep_comm_ptr->size_rank_info[0].second];
+
+
+    MPI_Allgather(my_triple, 3, MPI_INT, my_triple_list, 3, MPI_INT, *newintracomm);
+
+    if((*newintracomm)->ep_comm_ptr->size_rank_info[1].first == 0)
+    {
+      (*newintracomm)->ep_rank_map->clear();
+      for(int i=0; i<(*newintracomm)->ep_comm_ptr->size_rank_info[0].second; i++)
+      {
+        (*newintracomm)->ep_rank_map->insert(std::pair< int, std::pair<int,int> >(my_triple_list[3*i], my_triple_list[3*i+1], my_triple_list[3*i+2]));
+      }
+    }
+
+#ifdef _showinfo
+    MPI_Barrier_local(inter_comm);
+    if((*newintracomm)->ep_comm_ptr->size_rank_info[0].first == 15)
+    {
+      for(std::map<int, std::pair<int, int> >::iterator it = (*newintracomm)->ep_rank_map->begin(); it != (*newintracomm)->ep_rank_map->end(); it++)
+      {
+        printf("(%d  %d  %d)\n", it->first, it->second.first, it->second.second);
+      }
+    }
+#endif
     
-    int my_ep_rank = high? inter_rank+remote_ep_size : inter_rank;
-    int my_ep_rank_loc = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].first;
-    int my_num_ep_loc = inter_comm.ep_comm_ptr->intercomm->local_comm->ep_comm_ptr->size_rank_info[1].second;
-    int my_num_ep_total = inter_comm.ep_comm_ptr->comm_list->mem_bridge[0].ep_comm_ptr->size_rank_info[1].second;
-    int my_ep_size = inter_comm.ep_comm_ptr->comm_list->mem_bridge[0].ep_comm_ptr->size_rank_info[0].second;
-
-    int tmp_intra_ep_rank_loc = high?my_ep_rank_loc+my_num_ep_total-my_num_ep_loc: my_ep_rank_loc;
-
-
-    *newintracomm = inter_comm.ep_comm_ptr->comm_list->mem_bridge[tmp_intra_ep_rank_loc];
-
-    int newintracomm_ep_rank = (*newintracomm).ep_comm_ptr->size_rank_info[0].first;
-    int newintracomm_ep_rank_loc = (*newintracomm).ep_comm_ptr->size_rank_info[1].first;
-    int newintracomm_mpi_rank = (*newintracomm).ep_comm_ptr->size_rank_info[2].first;
-    int newintracomm_ep_size = (*newintracomm).ep_comm_ptr->size_rank_info[0].second;
-    int newintracomm_num_ep = (*newintracomm).ep_comm_ptr->size_rank_info[1].second;
-    int newintracomm_mpi_size = (*newintracomm).ep_comm_ptr->size_rank_info[2].second;
-
-
-    int buf[3];
-    buf[0] = my_ep_rank;
-    buf[1] = tmp_intra_ep_rank_loc;
-    buf[2] = newintracomm->ep_comm_ptr->size_rank_info[2].first;
-
-    // printf("my_ep_rank = %d, tmp_intra_ep_rank_loc = %d, mpi_rank = %d\n", my_ep_rank, tmp_intra_ep_rank_loc, newintracomm->ep_comm_ptr->size_rank_info[2].first);
-
-    int *rankmap_buf;
-    rankmap_buf = new int [3*my_ep_size];
-
-    MPI_Allgather(buf, 3, MPI_INT, rankmap_buf, 3, MPI_INT, *newintracomm);
-
-    
-    // printf(" ID = %d : rankmap_buf = (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d), (%d %d %d)\n", newintracomm_ep_rank,
-    //                     rankmap_buf[0], rankmap_buf[1], rankmap_buf[2], rankmap_buf[3], rankmap_buf[4], rankmap_buf[5], rankmap_buf[6], rankmap_buf[7], rankmap_buf[8], rankmap_buf[9],
-    //                     rankmap_buf[10], rankmap_buf[11], rankmap_buf[12], rankmap_buf[13], rankmap_buf[14], rankmap_buf[15], rankmap_buf[16], rankmap_buf[17], rankmap_buf[18], rankmap_buf[19], 
-    //                     rankmap_buf[20], rankmap_buf[21], rankmap_buf[22], rankmap_buf[23], rankmap_buf[24], rankmap_buf[25], rankmap_buf[26], rankmap_buf[27], rankmap_buf[28], rankmap_buf[29],
-    //                     rankmap_buf[30], rankmap_buf[31], rankmap_buf[32], rankmap_buf[33], rankmap_buf[34], rankmap_buf[35], rankmap_buf[36], rankmap_buf[37], rankmap_buf[38], rankmap_buf[39],
-    //                     rankmap_buf[40], rankmap_buf[41], rankmap_buf[42], rankmap_buf[43], rankmap_buf[44], rankmap_buf[45], rankmap_buf[46], rankmap_buf[47]);
-
-
-    for(int i=0; i<newintracomm_ep_size; i++)
-    {
-      (*newintracomm).rank_map->at(rankmap_buf[3*i]).first  = rankmap_buf[3*i+1];
-      (*newintracomm).rank_map->at(rankmap_buf[3*i]).second = rankmap_buf[3*i+2];
-    }
-
-
-    (*newintracomm).ep_comm_ptr->size_rank_info[0].first = my_ep_rank;
-    (*newintracomm).ep_comm_ptr->size_rank_info[1].first = tmp_intra_ep_rank_loc;
-    
-
-    delete[] rankmap_buf;
-
-    
-    return MPI_SUCCESS;
-
+    delete my_triple_list;
   }
-
-
+  
 }
